/*
 * Configuration settings for the Baikal-T1 based boards.
 *
 * Copyright 2019-2020, Baikal Electronics JSC
 *
 * Authors:
 *   Sergey Semin <sergey.semin@t-platforms.ru>
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */
#ifndef __CONFIG_BE_BFK3_H
#define __CONFIG_BE_BFK3_H

/*
 *-----------------------------------------------
 * Default Baikal-T1 config macro
 *-----------------------------------------------
 */
#include <configs/baikal_mips.h>

/*
 *-----------------------------------------------
 * DDR parameters
 *-----------------------------------------------
 */
#define BAIKAL_SPD_NAME		"eeprom@50"

/*
 *-----------------------------------------------
 * Generic Configurations
 *-----------------------------------------------
 */
#ifdef CONFIG_BOARD_BFK3
#define BOARD_NAME			"BFK3"
#elif defined(CONFIG_BOARD_BFKX)
#define BOARD_NAME			"BFKX"

#define BAIKAL_EEPROM_NAME	"eeprom@51"
#define BAIKAL_EEPROM_SIZE	256

#define BAIKAL_EEPROM_VENDOR_OFFSET	192
#define BAIKAL_EEPROM_MAC0_OFFSET	208
#define BAIKAL_EEPROM_MAC1_OFFSET	214
#define BAIKAL_EEPROM_MAC2_OFFSET	220
#define BAIKAL_EEPROM_MAX_IFACES	3

#undef BAIKAL_SPD_NAME
#endif

/*
 *-----------------------------------------------
 * Misc parameters
 *-----------------------------------------------
 */

/*
 *-----------------------------------------------
 * Default boot parameters
 *-----------------------------------------------
 */
/* U-Boot config information */
#define CONFIG_ENV_VARS_UBOOT_CONFIG
/* Default variables */
#define CONFIG_PCI_BOOTDELAY		3
#define CONFIG_BOOTARGS			"mem=128M console=ttyS0,mmio32,115200"
#define CONFIG_BOOTCOMMAND 		"sf probe; sf read 0x81000000 0x00400000 0x00400000; bootm 0x81000000"
#define CONFIG_RAMBOOTCOMMAND 		""
#define CONFIG_NFSBOOTCOMMAND		""
#define CONFIG_ETHPRIME			"eth0"
#define CONFIG_ETHADDR 			de:ad:be:ef:01:01
#define CONFIG_ETH1ADDR			de:ad:be:ef:01:02
#define CONFIG_ETH2ADDR			de:ad:be:ef:01:03
#define CONFIG_IPADDR 			192.168.66.226
#define CONFIG_SERVERIP			192.168.66.151
#define CONFIG_GATEWAYIP		192.168.66.1
#define CONFIG_NETMASK			255.255.255.0
#define CONFIG_HOSTNAME			"baikal"
#define CONFIG_ROOTPATH			"/tftpboot/"
#define CONFIG_BOOTFILE			"uImage"
#define CONFIG_LOADADDR 		CONFIG_SYS_LOAD_ADDR

#endif /* __CONFIG_BE_BFK3_H */
